diff --git a/game/client/src/main/java/net/minecraft/client/gui/ClickableLabelElement.java b/game/client/src/main/java/net/minecraft/client/gui/ClickableLabelElement.java
index 868eabf83..8f833c0d6 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ClickableLabelElement.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ClickableLabelElement.java
@@ -1,28 +1,45 @@
 package net.minecraft.client.gui;
 
 import net.minecraft.client.Minecraft;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.window.CursorShape;
 import net.minecraft.core.util.helper.MathHelper;
+import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
 
-public class ClickableLabelElement extends ButtonElement
-{
+import static net.minecraft.client.render.OpenGLHelper.glColor1i;
+
+public class ClickableLabelElement extends ButtonElement {
     private int textColor;
     private int bgColor;
     private boolean shadow = true;
+    private final @Nullable IconCoordinate icon;
 
-    public ClickableLabelElement(int id, int xPosition, int yPosition, String s, int textColor, int bgColor)
-    {
+    public ClickableLabelElement(int id, int xPosition, int yPosition, String s, int textColor, int bgColor, @Nullable String icon) {
         super(id, xPosition, yPosition, s);
+
         this.textColor = textColor;
         this.bgColor = bgColor;
-        height = 12;
-        width = 0;
+        this.height = 12;
+        this.width = 0;
+        if (icon != null) {
+            this.icon = TextureRegistry.getTexture(icon);
+        } else {
+            this.icon = null;
+        }
+    }
+
+    public ClickableLabelElement(int id, int xPosition, int yPosition, String s, int textColor, int bgColor) {
+        this(id, xPosition, yPosition, s, textColor, bgColor, null);
+    }
+
+    public ClickableLabelElement(int id, int xPosition, int yPosition, String s, int textColor, @Nullable String icon) {
+        this(id, xPosition, yPosition, s, textColor, 0x7F000000, icon);
     }
 
-    public ClickableLabelElement(int id, int xPosition, int yPosition, String s, int textColor)
-    {
-        this(id, xPosition, yPosition, s, textColor, 0x7F000000);
+    public ClickableLabelElement(int id, int xPosition, int yPosition, String s, int textColor) {
+        this(id, xPosition, yPosition, s, textColor, null);
     }
 
     public int getTextColor() {
@@ -50,10 +67,8 @@ public class ClickableLabelElement extends ButtonElement
     }
 
     @Override
-    public void drawButton(Minecraft mc, int mouseX, int mouseY)
-    {
-        if(!visible)
-        {
+    public void drawButton(Minecraft mc, int mouseX, int mouseY) {
+        if (!visible) {
             return;
         }
 
@@ -62,15 +77,54 @@ public class ClickableLabelElement extends ButtonElement
             mc.currentScreen.setDesiredCursor(CursorShape.HAND);
         }
 
-        GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
-        width = MathHelper.ceil(mc.font.stringWidthDouble(displayString)) + 4;
+        if (this.icon != null) {
+            if (hovered && enabled) {
+                this.width = 2 + this.icon.width + 4 + MathHelper.ceil(mc.font.stringWidthDouble(displayString)) + 2;
+            } else {
+                this.width = 2 + this.icon.width + 2;
+            }
+        } else {
+            width = MathHelper.ceil(mc.font.stringWidthDouble(displayString)) + 4;
+        }
+
         drawRect(xPosition, yPosition, xPosition + width, yPosition + height, enabled ? (hovered ? 0x7F8080C0 : bgColor) : 0x00000000);
-        if (enabled && (shadow || hovered)) {
-            drawStringShadow(mc.font, displayString, xPosition + 2, yPosition + 2, hovered ? 0xFFFFA0 : textColor);
+
+        if (this.icon != null) {
+            if (hovered) {
+                if (shadow) {
+                    glColor1i(makeShadow(0xFFFFFFA0));
+                    drawGuiIcon(xPosition + 3, yPosition + 2, icon.width, icon.height, icon);
+                    glColor1i(0xFFFFFFA0);
+                    drawGuiIcon(xPosition + 2, yPosition + 1, icon.width, icon.height, icon);
+                    drawStringShadow(mc.font, displayString, xPosition + 4 + icon.width + 2, yPosition + 2, 0xFFFFFFA0);
+                } else {
+                    glColor1i(0xFFFFFFA0);
+                    drawGuiIcon(xPosition + 2, yPosition + 1, icon.width, icon.height, icon);
+                    drawStringNoShadow(mc.font, displayString, xPosition + 4 + icon.width + 2, yPosition + 2, 0xFFFFFFA0);
+                }
+            } else {
+                if (shadow) {
+                    glColor1i(makeShadow(textColor));
+                    drawGuiIcon(xPosition + 3, yPosition + 2, icon.width, icon.height, icon);
+                    glColor1i(textColor);
+                    drawGuiIcon(xPosition + 2, yPosition + 1, icon.width, icon.height, icon);
+                } else {
+                    glColor1i(textColor);
+                    drawGuiIcon(xPosition + 2, yPosition + 1, icon.width, icon.height, icon);
+                }
+            }
         } else {
-            drawStringNoShadow(mc.font, displayString, xPosition + 2, yPosition + 2, 0x7F7F7F);
+            if (enabled && (shadow || hovered)) {
+                drawStringShadow(mc.font, displayString, xPosition + 4, yPosition + 2, hovered ? 0xFFFFFFA0 : textColor);
+            } else {
+                drawStringNoShadow(mc.font, displayString, xPosition + 4, yPosition + 2, 0xFF7F7F7F);
+            }
         }
+
         mouseDragged(mc, mouseX, mouseY);
     }
 
+    private static int makeShadow(int argb) {
+        return ((argb & 0xFCFCFC) >> 2) | (argb & 0xFF000000);
+    }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenCreateWorld.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenCreateWorld.java
index 463be32ef..36795cfd2 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenCreateWorld.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenCreateWorld.java
@@ -8,21 +8,17 @@ import net.minecraft.core.item.Items;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.net.command.TextFormatting;
 import net.minecraft.core.player.gamemode.Gamemode;
-import net.minecraft.core.util.helper.ChatAllowedCharacters;
-import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.Dimension;
-import net.minecraft.core.world.save.ISaveFormat;
+import net.minecraft.core.world.settings.WorldConfiguration;
 import net.minecraft.core.world.type.WorldTypeGroups;
 import org.lwjgl.input.Keyboard;
 
 import java.util.List;
-import java.util.Random;
 
 public class ScreenCreateWorld extends Screen {
     private int overrideSpawnX;
     private int overrideSpawnY;
     private int overrideSpawnZ;
-    private Screen textField;
     private TextFieldElement textboxWorldName;
     private TextFieldElement textboxSeed;
     private ButtonElement createWorldButton;
@@ -31,15 +27,11 @@ public class ScreenCreateWorld extends Screen {
     private ButtonElement worldTypeButton;
     private ButtonElement buttonRandomWorldName;
     private ButtonElement buttonRandomSeed;
-    private String folderName;
     private boolean createClicked;
-    private Gamemode selectedGamemode = Gamemode.survival;
-    private boolean cheatsEnabled = false;
-    private WorldTypeGroups.Group worldTypeGroup = WorldTypeGroups.DEFAULT;
-    private long seed = (new Random()).nextLong();
+    private final WorldConfiguration worldConfiguration = new WorldConfiguration();
 
-    public ScreenCreateWorld(Screen guiscreen) {
-        textField = guiscreen;
+    public ScreenCreateWorld(Screen parent) {
+        super(parent);
     }
 
     @Override
@@ -54,44 +46,21 @@ public class ScreenCreateWorld extends Screen {
         Keyboard.enableRepeatEvents(true);
         buttons.clear();
         buttons.add(createWorldButton = new ButtonElement(0, width / 2 - 100, height / 4 + 104 + 12,
-            i18n.translateKey("gui.create_world.button.create_new_world")));
+                i18n.translateKey("gui.create_world.button.create_new_world")));
         buttons.add(new ButtonElement(1, width / 2 - 100, height / 4 + 128 + 12,
-            i18n.translateKey("gui.create_world.button.cancel")));
+                i18n.translateKey("gui.create_world.button.cancel")));
         textboxWorldName = new TextFieldElement(this, fontRenderer, width / 2 - 100, 60, 200 - 24, 20,
-            "", i18n.translateKey("gui.create_world.label.new_world"));
+                "", i18n.translateKey("gui.create_world.label.new_world"));
         textboxWorldName.setMaxStringLength(32);
-        textboxSeed = new TextFieldElement(this, fontRenderer, width / 2 - 100, 100, 200 - 24, 20, "", Long.toString(seed));
+        textboxSeed = new TextFieldElement(this, fontRenderer, width / 2 - 100, 100, 200 - 24, 20, "", Long.toString(this.worldConfiguration.getNumericSeed()));
         buttons.add(gamemodeButton = new ButtonElement(2, width / 2 - 100, 100 + 20 + 4, 98, 20, ""));
         buttons.add(cheatsButton = new ButtonElement(3, width / 2 - 100 + 102, 100 + 20 + 4, 98, 20, ""));
         buttons.add(worldTypeButton = new ButtonElement(4, width / 2 - 100, 100 + 20 + 20 + 4 + 4, ""));
         buttons.add(buttonRandomWorldName = new ButtonElement(5, width / 2 + 100 - 20, 60, 20, 20, "")
-            .setTextures("minecraft:gui/misc/button_random", "minecraft:gui/misc/button_random_highlighted", "minecraft:gui/misc/button_random"));
+                .setTextures("minecraft:gui/misc/button_random", "minecraft:gui/misc/button_random_highlighted", "minecraft:gui/misc/button_random"));
         buttons.add(buttonRandomSeed = new ButtonElement(6, width / 2 + 100 - 20, 100, 20, 20, "")
-            .setTextures("minecraft:gui/misc/button_random", "minecraft:gui/misc/button_random_highlighted", "minecraft:gui/misc/button_random"));
-        updateButtons();
-        updateFolderName();
-    }
-
-    private void updateFolderName() {
-        folderName = textboxWorldName.getText().trim();
-        char[] ac = ChatAllowedCharacters.ALLOWED_CHARACTERS_ARRAY;
-        for (char c : ac) {
-            folderName = folderName.replace(c, '_');
-        }
-
-        if (MathHelper.stringNullOrLengthZero(folderName)) {
-            folderName = "New World";
-        }
-        folderName = generateUnusedFolderName(mc.getSaveFormat(), folderName);
-    }
-
-    public static String generateUnusedFolderName(ISaveFormat isaveformat, String s) {
-        int count = 1;
-        String newString = s;
-        for (; isaveformat.getLevelData(newString) != null; count++) {
-            newString = s + " (" + count + ")";
-        }
-        return newString;
+                .setTextures("minecraft:gui/misc/button_random", "minecraft:gui/misc/button_random_highlighted", "minecraft:gui/misc/button_random"));
+        syncButtons();
     }
 
     @Override
@@ -105,48 +74,25 @@ public class ScreenCreateWorld extends Screen {
             return;
         }
         if (button.id == 1) {
-            mc.displayScreen(textField);
+            mc.displayScreen(parentScreen);
         } else if (button.id == 0) {
             mc.displayScreen(null);
             if (createClicked) {
                 return;
             }
             createClicked = true;
-            long seed = this.seed;
-            String seedText = textboxSeed.getText();
-            if (!MathHelper.stringNullOrLengthZero(seedText)) {
-                try {
-                    long parsedSeed = Long.parseLong(seedText);
-                    if (parsedSeed != 0L) {
-                        seed = parsedSeed;
-                    }
-                } catch (NumberFormatException e) {
-                    seed = seedText.hashCode();
-                }
-            }
-            mc.playerController = new PlayerControllerSP(mc);
-            String worldName = textboxWorldName.getText();
-            if (worldName.isEmpty()) {
-                worldName = I18n.getInstance().translateKey("gui.create_world.label.new_world");
-            }
-            mc.startWorld(folderName, worldName, seed, worldTypeGroup);
-            mc.thePlayer.setGamemode(selectedGamemode);
-            if (selectedGamemode == Gamemode.adventure) {
-                mc.thePlayer.inventory.insertItem(Items.TOOL_AXE_WOOD.getDefaultStack(), true);
-            }
-            if (mc.worldPresetName != null) mc.thePlayer.setPos(overrideSpawnX, overrideSpawnY, overrideSpawnZ);
-            mc.currentWorld.getLevelData().setCheatsEnabled(cheatsEnabled);
+
+            this.mc.createAndStartWorld(this.worldConfiguration);
+
             mc.displayScreen(null);
         } else if (button == gamemodeButton) {
-            I18n i18n = I18n.getInstance();
             List<Gamemode> gamemodeList = Gamemode.getPublicGamemodes();
-            selectedGamemode = gamemodeList.get((gamemodeList.indexOf(selectedGamemode) + 1) % gamemodeList.size());
-            cheatsEnabled = selectedGamemode == Gamemode.creative;
-            updateButtons();
+            this.worldConfiguration.setGamemode(gamemodeList.get((gamemodeList.indexOf(this.worldConfiguration.getGamemode()) + 1) % gamemodeList.size()));
+            this.worldConfiguration.setCheatsEnabled(this.worldConfiguration.getGamemode() == Gamemode.creative);
+            syncButtons();
         } else if (button == cheatsButton) {
-            I18n i18n = I18n.getInstance();
-            cheatsEnabled = !cheatsEnabled;
-            updateButtons();
+            this.worldConfiguration.setCheatsEnabled(!this.worldConfiguration.getCheatsEnabled());
+            syncButtons();
         } else if (button == worldTypeButton) {
             I18n i18n = I18n.getInstance();
             String[] keys = new String[WorldTypeGroups.GROUPS.size()];
@@ -154,37 +100,45 @@ public class ScreenCreateWorld extends Screen {
             for (int i = 0; i < keys.length; i++) {
                 keys[i] = i18n.translateKey(WorldTypeGroups.GROUPS.get(i).get(Dimension.OVERWORLD).getLanguageKey() + ".name");
                 descs[i] = i18n.translateKey(WorldTypeGroups.GROUPS.get(i).get(Dimension.OVERWORLD).getLanguageKey() + ".desc") + "\n" +
-                    TextFormatting.GRAY + Registries.WORLD_TYPES.getKey(WorldTypeGroups.GROUPS.get(i).get(Dimension.OVERWORLD));
+                        TextFormatting.GRAY + Registries.WORLD_TYPES.getKey(WorldTypeGroups.GROUPS.get(i).get(Dimension.OVERWORLD));
             }
 
             PopupScreen popup = new PopupBuilder(this, 150)
-                .closeOnEsc(0)
-                .closeOnClickOut(0)
-                .withLabel("gui.create_world.label.select_world_type")
-                .withList("worldTypeList", 140, keys, descs, WorldTypeGroups.GROUPS.indexOf(worldTypeGroup), true)
-                .withOnCloseListener((statusCode, results) -> {
-                    if (statusCode == 1) {
-                        worldTypeGroup = WorldTypeGroups.GROUPS.get((Integer) results.get("worldTypeList"));
-                        updateButtons();
-                    }
-                })
-                .build();
+                    .closeOnEsc(0)
+                    .closeOnClickOut(0)
+                    .withLabel("gui.create_world.label.select_world_type")
+                    .withList("worldTypeList", 140, keys, descs, WorldTypeGroups.GROUPS.indexOf(this.worldConfiguration.getWorldTypeGroup()), true)
+                    .withOnCloseListener((statusCode, results) -> {
+                        if (statusCode == 1) {
+                            this.worldConfiguration.setWorldTypeGroup(WorldTypeGroups.GROUPS.get((Integer) results.get("worldTypeList")));
+                            syncButtons();
+                        }
+                    })
+                    .build();
             mc.displayScreen(popup);
         } else if (button == buttonRandomWorldName) {
             textboxWorldName.setText(I18n.getInstance().getCurrentLanguage().getRandomWorldName());
-            updateFolderName();
+            syncConfig();
         } else if (button == buttonRandomSeed) {
-            this.seed = (new Random()).nextLong();
-            textboxSeed.setPlaceholder(Long.toString(seed));
+            this.worldConfiguration.regenNumericSeed();
+            textboxSeed.setPlaceholder(Long.toString(this.worldConfiguration.getNumericSeed()));
             textboxSeed.setText("");
+            syncConfig();
         }
     }
 
-    private void updateButtons() {
+    private void syncButtons() {
         I18n i18n = I18n.getInstance();
-        gamemodeButton.displayString = i18n.translateKeyAndFormat("gui.create_world.button.gamemode", i18n.translateKey(selectedGamemode.getLanguageKey() + ".name"));
-        cheatsButton.displayString = i18n.translateKeyAndFormat("gui.create_world.button.cheats", i18n.translateKey(cheatsEnabled ? "gui.create_world.button.cheats.on" : "gui.create_world.button.cheats.off"));
-        worldTypeButton.displayString = i18n.translateKeyAndFormat("gui.create_world.button.world_type", i18n.translateKey(worldTypeGroup.get(Dimension.OVERWORLD).getLanguageKey() + ".name"));
+        this.textboxWorldName.setText(this.worldConfiguration.getWorldName());
+        this.textboxSeed.setText(this.worldConfiguration.getStringSeed());
+        gamemodeButton.displayString = i18n.translateKeyAndFormat("gui.create_world.button.gamemode", i18n.translateKey(this.worldConfiguration.getGamemode().getLanguageKey() + ".name"));
+        cheatsButton.displayString = i18n.translateKeyAndFormat("gui.create_world.button.cheats", i18n.translateKey(this.worldConfiguration.getCheatsEnabled() ? "gui.create_world.button.cheats.on" : "gui.create_world.button.cheats.off"));
+        worldTypeButton.displayString = i18n.translateKeyAndFormat("gui.create_world.button.world_type", i18n.translateKey(this.worldConfiguration.getWorldTypeGroup().get(Dimension.OVERWORLD).getLanguageKey() + ".name"));
+    }
+
+    private void syncConfig() {
+        this.worldConfiguration.setWorldName(this.textboxWorldName.getText());
+        this.worldConfiguration.setStringSeed(this.textboxSeed.getText());
     }
 
     @Override
@@ -192,13 +146,14 @@ public class ScreenCreateWorld extends Screen {
         if (eventKey != Keyboard.KEY_BACK) super.keyPressed(eventCharacter, eventKey, mx, my);
         if (textboxWorldName.isFocused) {
             textboxWorldName.textboxKeyTyped(eventCharacter, eventKey);
+            syncConfig();
         } else if (textboxSeed.isFocused) {
             textboxSeed.textboxKeyTyped(eventCharacter, eventKey);
+            syncConfig();
         }
         if (eventCharacter == '\r') {
             buttonClicked(buttons.get(0));
         }
-        updateFolderName();
     }
 
     @Override
@@ -210,11 +165,11 @@ public class ScreenCreateWorld extends Screen {
 
     @Override
     public void render(int mx, int my, float partialTick) {
-        I18n stringtranslate = I18n.getInstance();
+        I18n i18n = I18n.getInstance();
         renderBackground();
-        drawStringCenteredShadow(fontRenderer, stringtranslate.translateKey("gui.create_world.label.title"), width / 2, 20, 0xffffff);
-        drawStringShadow(fontRenderer, stringtranslate.translateKey("gui.create_world.label.world_name"), width / 2 - 100, 47, 0xa0a0a0);
-        drawStringShadow(fontRenderer, stringtranslate.translateKey("gui.create_world.label.seed"), width / 2 - 100, 88, 0xa0a0a0);
+        drawStringCenteredShadow(fontRenderer, i18n.translateKey("gui.create_world.label.title"), width / 2, 20, 0xffffff);
+        drawStringShadow(fontRenderer, i18n.translateKey("gui.create_world.label.world_name"), width / 2 - 100, 47, 0xa0a0a0);
+        drawStringShadow(fontRenderer, i18n.translateKey("gui.create_world.label.seed"), width / 2 - 100, 88, 0xa0a0a0);
         textboxWorldName.drawTextBox();
         textboxWorldName.updateCursor(mc, mx, my);
         textboxSeed.drawTextBox();
@@ -237,10 +192,9 @@ public class ScreenCreateWorld extends Screen {
         overrideSpawnX = spawnX;
         overrideSpawnY = spawnY;
         overrideSpawnZ = spawnZ;
-        textboxWorldName.setText(name);
-        textboxSeed.setText(seed);
-        updateFolderName();
-        selectedGamemode = Gamemode.creative;
+        this.worldConfiguration.setWorldName(name);
+        this.worldConfiguration.setStringSeed(seed);
+        this.worldConfiguration.setGamemode(Gamemode.creative);
         buttonClicked(createWorldButton);
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenHudDesigner.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenHudDesigner.java
index 511d5a750..52a06c8ca 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenHudDesigner.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenHudDesigner.java
@@ -70,8 +70,8 @@ public class ScreenHudDesigner
                 if (componentUnderMouse instanceof HudComponentMovable) {
                     Layout currentLayout = componentUnderMouse.getLayout();
                     ComponentAnchor anchor = getClosestAnchor(
-                        currentLayout.getComponentX(mc, componentUnderMouse, width),
-                        currentLayout.getComponentY(mc, componentUnderMouse, height - BOTTOM_SPACE),
+                        currentLayout.getComponentX(componentUnderMouse, width),
+                        currentLayout.getComponentY(componentUnderMouse, height - BOTTOM_SPACE),
                         componentUnderMouse, mx, my);
                     Layout layout = new LayoutAbsolute(0, 0, anchor);
                     ((HudComponentMovable) componentUnderMouse).setLayout(layout);
@@ -92,8 +92,8 @@ public class ScreenHudDesigner
     private void updateHeldComponent(int mouseX, int mouseY) {
         if (heldComponent == null) return;
 
-        int xSize = heldComponent.getXSize(mc);
-        int ySize = heldComponent.getYSize(mc);
+        int xSize = heldComponent.getXSize();
+        int ySize = heldComponent.getYSize();
         int xOffset = heldComponent.getAnchorX(heldAnchor);
         int yOffset = heldComponent.getAnchorY(heldAnchor);
         int newX = MathHelper.clamp(mouseX, xOffset, width - (xSize - xOffset));
@@ -111,7 +111,7 @@ public class ScreenHudDesigner
         boolean didSnap = false;
         for (HudComponent component : HudComponents.INSTANCE.getComponents()) {
             if (component == heldComponent) continue;
-            if (!component.isEnabled(mc)) continue;
+            if (!component.isEnabled()) continue;
             Layout otherLayout = component.getLayout();
             boolean isNested = false;
             Layout nestedLayout = otherLayout;
@@ -132,8 +132,8 @@ public class ScreenHudDesigner
             }
             if (isNested) continue;
 
-            int x = otherLayout.getComponentX(mc, component, width);
-            int y = otherLayout.getComponentY(mc, component, height - BOTTOM_SPACE);
+            int x = otherLayout.getComponentX(component, width);
+            int y = otherLayout.getComponentY(component, height - BOTTOM_SPACE);
 
             // Get mouse distance
             int mouseDistance = (int) Math.sqrt(Math.pow(mouseX - newX, 2) + Math.pow(mouseY - newY, 2));
@@ -293,15 +293,15 @@ public class ScreenHudDesigner
         }
         for (HudComponent component : HudComponents.INSTANCE.getComponents()) {
             if (component == heldComponent) continue;
-            if (!component.isEnabled(mc)) continue;
+            if (!component.isEnabled()) continue;
             Layout layout = component.getLayout();
-            component.renderPreview(mc, this, layout, width, height - BOTTOM_SPACE);
+            component.renderPreview(this, layout, width, height - BOTTOM_SPACE);
             if (heldComponent == null) {
                 if (!componentsUnderMouse.isEmpty() && component == lastComponent) {
-                    int x = layout.getComponentX(mc, component, width);
-                    int y = layout.getComponentY(mc, component, height - BOTTOM_SPACE);
-                    int xSize = component.getXSize(mc);
-                    int ySize = component.getYSize(mc);
+                    int x = layout.getComponentX(component, width);
+                    int y = layout.getComponentY(component, height - BOTTOM_SPACE);
+                    int xSize = component.getXSize();
+                    int ySize = component.getYSize();
                     drawBox(x, y, x + xSize, y + ySize, 0xff00ff00, 1);
                     ComponentAnchor anchor = getClosestAnchor(x, y, component, mouseX, mouseY);
                     int xAnchor = component.getAnchorX(anchor);
@@ -313,11 +313,11 @@ public class ScreenHudDesigner
         }
         if (heldComponent != null) {
             Layout layout = heldComponent.getLayout();
-            heldComponent.renderPreview(mc, this, layout, width, height - BOTTOM_SPACE);
-            int x = layout.getComponentX(mc, heldComponent, width);
-            int y = layout.getComponentY(mc, heldComponent, height - BOTTOM_SPACE);
-            int xSize = heldComponent.getXSize(mc);
-            int ySize = heldComponent.getYSize(mc);
+            heldComponent.renderPreview(this, layout, width, height - BOTTOM_SPACE);
+            int x = layout.getComponentX(heldComponent, width);
+            int y = layout.getComponentY(heldComponent, height - BOTTOM_SPACE);
+            int xSize = heldComponent.getXSize();
+            int ySize = heldComponent.getYSize();
             int xAnchor = heldComponent.getAnchorX(heldAnchor);
             int yAnchor = heldComponent.getAnchorY(heldAnchor);
             drawBox(x, y, x + xSize, y + ySize, 0xffff0000, 1);
@@ -325,8 +325,8 @@ public class ScreenHudDesigner
         }
         if (snappedComponent != null && snappedAnchor != null) {
             Layout layout = snappedComponent.getLayout();
-            int x = layout.getComponentX(mc, snappedComponent, width);
-            int y = layout.getComponentY(mc, snappedComponent, height - BOTTOM_SPACE);
+            int x = layout.getComponentX(snappedComponent, width);
+            int y = layout.getComponentY(snappedComponent, height - BOTTOM_SPACE);
             int xAnchor = snappedComponent.getAnchorX(snappedAnchor);
             int yAnchor = snappedComponent.getAnchorY(snappedAnchor);
             drawAnchor(x, y, xAnchor, yAnchor, snappedAnchor);
@@ -379,12 +379,12 @@ public class ScreenHudDesigner
     private void updateComponentsUnderMouse(int mouseX, int mouseY) {
         componentsUnderMouse.clear();
         for (HudComponent component : HudComponents.INSTANCE.getComponents()) {
-            if (!component.isEnabled(mc)) continue;
+            if (!component.isEnabled()) continue;
             Layout layout = component.getLayout();
-            int cx = layout.getComponentX(mc, component, width);
-            int cy = layout.getComponentY(mc, component, height - BOTTOM_SPACE);
-            int cXSize = component.getXSize(mc);
-            int cYSize = component.getYSize(mc);
+            int cx = layout.getComponentX(component, width);
+            int cy = layout.getComponentY(component, height - BOTTOM_SPACE);
+            int cXSize = component.getXSize();
+            int cYSize = component.getYSize();
             if (mouseX >= cx && mouseX < cx + cXSize && mouseY >= cy && mouseY < cy + cYSize) {
                 componentsUnderMouse.add(component);
             }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenMainMenu.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenMainMenu.java
index a3936a5b1..c67571377 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenMainMenu.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenMainMenu.java
@@ -67,8 +67,7 @@ public class ScreenMainMenu extends Screen
     private int codeProgress = 0;
     private boolean showBuildTime = false;
     private String buildTimeString = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(new Date(Version.BUILD_TIME));
-    private int snowfallTimer = 0;
-    
+
     static {
     	loadLogo();
     }
@@ -178,10 +177,10 @@ public class ScreenMainMenu extends Screen
             buttons.add(new ButtonElement(4, width / 2 + 2, i + 72 + 12, 98, 20, i18n.translateKey("gui.main_menu.button.quit_game")));
         }
         int d = 1; // Move away from the edge of the screen to prevent unintentional activation because the cursor defaults to 0, 0
-        buttons.add(new ClickableLabelElement(5, d, height - 48 - d, i18n.translateKey("gui.main_menu.button.credits"), 0x9F9F9F));
-        buttons.add(new ClickableLabelElement(6, d, height - 36 - d, i18n.translateKey("gui.main_menu.button.website"), 0x5AA938));
-        buttons.add(new ClickableLabelElement(7, d, height - 24 - d, i18n.translateKey("gui.main_menu.button.discord"), 0x5865F2));
-        buttons.add(new ClickableLabelElement(8, d, height - 12 - d, i18n.translateKey("gui.main_menu.button.youtube"), 0xFF0000));
+        buttons.add(new ClickableLabelElement(5, d, height - 48 - d, i18n.translateKey("gui.main_menu.button.credits"), 0xFF9F9F9F, "minecraft:gui/screen/main_menu/icon_credits"));
+        buttons.add(new ClickableLabelElement(6, d, height - 36 - d, i18n.translateKey("gui.main_menu.button.website"), 0xFF5AA938, "minecraft:gui/screen/main_menu/icon_website"));
+        buttons.add(new ClickableLabelElement(7, d, height - 24 - d, i18n.translateKey("gui.main_menu.button.discord"), 0xFF5865F2, "minecraft:gui/screen/main_menu/icon_discord"));
+        buttons.add(new ClickableLabelElement(8, d, height - 12 - d, i18n.translateKey("gui.main_menu.button.youtube"), 0xFFFF0000, "minecraft:gui/screen/main_menu/icon_youtube"));
         buttons.add(new ButtonElement(9, width / 2 + 104, i + 72 + 12, 20, 20, "")
             .setTextures("minecraft:gui/misc/button_language", "minecraft:gui/misc/button_language_highlighted", "minecraft:gui/misc/button_language"));
         ButtonElement debugButton = new ButtonElement(10, width - 8, height - 8, 8, 8, "");
@@ -460,11 +459,6 @@ public class ScreenMainMenu extends Screen
         GL11.glEnable(GL11.GL_CULL_FACE);
     }
 
-
-    static Random getRandom() {
-        return rand;
-    }
-    
     public static void loadLogo() {
     	try {
     		InputStream inputStream = ScreenMainMenu.class.getResourceAsStream("/assets/minecraft/textures/gui/title/retrologo.png");
